﻿Morph subclass: #ArrowMorph
	instanceVariableNames: 'lineWidth '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ArrowMorph Lesson'!

!ArrowMorph methodsFor: 'initialization' stamp: 'mu 5/31/2004 19:58'!
initialize
	super initialize.
	lineWidth _ 1.
! !


!ArrowMorph methodsFor: 'drawing' stamp: 'mu 5/31/2004 19:58'!
drawOn: aCanvas
	aCanvas line: self topCenter to: self bottomCenter width: lineWidth color: self color.
	aCanvas line: self topCenter to: self leftCenter width: lineWidth color: self color.
	aCanvas line: self topCenter to: self rightCenter width: lineWidth color: self color.
! !


!ArrowMorph methodsFor: 'geometry' stamp: 'mu 6/1/2004 01:36'!
outerBounds
	^super outerBounds expandBy: 5
! !


!ArrowMorph methodsFor: 'stepping' stamp: 'mu 6/1/2004 01:44'!
step
	self color: Color random.
	lineWidth _ lineWidth + 1.
	lineWidth > 5 ifTrue: [lineWidth _ 1].

	self width < 10 ifTrue: [self bounds: (self bounds expandBy: 10@0) ].
	self height < 10 ifTrue: [self bounds: (self bounds expandBy: 0@10) ].
! !

!ArrowMorph methodsFor: 'stepping' stamp: 'mu 5/31/2004 19:22'!
stepTime
	^200
! !


!ArrowMorph methodsFor: 'event handling' stamp: 'mu 6/1/2004 01:23'!
handlesKeyboard: anEvent
	^true
! !

!ArrowMorph methodsFor: 'event handling' stamp: 'mu 6/1/2004 00:40'!
handlesMouseDown: anEvent
	^true
! !

!ArrowMorph methodsFor: 'event handling' stamp: 'mu 6/1/2004 01:04'!
handlesMouseOver: anEvent
	^true
! !

!ArrowMorph methodsFor: 'event handling' stamp: 'mu 6/1/2004 01:31'!
keyStroke: anEvent
	| character |
	character _ anEvent keyCharacter.	"どの文字が押されたか取り出す"
	character = $j
		ifTrue: [self bounds: (self bounds expandBy: -1 @ 0)].
	character = $k
		ifTrue: [self bounds: (self bounds expandBy: 1 @ 0)].
	character = $i
		ifTrue: [self bounds: (self bounds expandBy: 0 @ 1)].
	character = $m
		ifTrue: [self bounds: (self bounds expandBy: 0 @ -1)]
!]lang[(70 14 291)0,5,0! !

!ArrowMorph methodsFor: 'event handling' stamp: 'mu 6/1/2004 01:37'!
mouseDown: anEvent 
	self center: anEvent cursorPoint	"自身の中心位置をカーソル位置に合わせる"
!]lang[(55 19 2)0,5,0! !

!ArrowMorph methodsFor: 'event handling' stamp: 'mu 6/1/2004 01:45'!
mouseEnter: anEvent
	self position: self position - (5@5).
	anEvent hand newKeyboardFocus: self.	"キーボードフォーカスを移す"
!]lang[(98 13 2)0,5,0! !

!ArrowMorph methodsFor: 'event handling' stamp: 'mu 6/1/2004 01:04'!
mouseLeave: anEvent
	self position: self position + (5@-5)
! !
