﻿"LayoutingMorphs"

"テーブル・レイアウトの外枠モーフを作ります"
morph _ Morph new.
morph extent: 200@150.
morph changeTableLayout.
morph listDirection: #bottomToTop.
morph listCentering: #center.
morph wrapCentering: #center.
morph layoutInset: 3; cellInset: 2.

"サブモーフを3つ追加します"
morph addMorph: (yellow _ Morph new color: Color yellow).
morph addMorph: (green _ Morph new color: Color green).
morph addMorph: (red _ Morph new color: Color red).

"それぞれの縦横のリサイズ指定を#spaceFillにします"
yellow hResizing: #spaceFill; vResizing:#spaceFill.
green hResizing:#spaceFill ; vResizing:#spaceFill.
red hResizing:#spaceFill ; vResizing:#spaceFill.

"黄色のサブモーフをプロポーショナル・レイアウトにして、
左よりのフレームをセットし、さらにサブモーフを追加します"
yellow changeProportionalLayout.
leftFrame _ LayoutFrame fractions: (0@0 corner: 0.3@1).
headerMorph _ Morph new color: Color random.
yellow addMorph: headerMorph fullFrame: leftFrame.

"緑のサブモーフをプロポーショナル・レイアウトにして、
内よりのフレームをセットし、さらにサブモーフを追加します"
green changeProportionalLayout.
innerFrame _ LayoutFrame fractions: (0.1@0.1 corner: 0.9@0.9).
innerMorph _ Morph new color: Color random.
green addMorph: innerMorph fullFrame: innerFrame.

"赤のサブモーフをプロポーショナル・レイアウトにして、
右よりのフレームをセットし、さらにサブモーフを追加します"
red changeProportionalLayout.
rightFrame _ LayoutFrame fractions: (0.7@0 corner: 1@1).
footerMorph _ Morph new color: Color random.
red addMorph: footerMorph fullFrame: rightFrame.

"最後にモーフをオープンします"
morph openInWorld.
