﻿'From SqueakNihongo6.1 of 15 April 2004 [latest update: #0] on 16 June 2004 at 6:03:07 pm'!
Error subclass: #BadFormatDateEntry
	instanceVariableNames: 'originalEntry '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exception Lesson-Date'!
Object subclass: #DateReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exception Lesson-Date'!
Error subclass: #OutOfRange
	instanceVariableNames: 'value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exception Lesson-Date'!
OutOfRange subclass: #DayOutOfRange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exception Lesson-Date'!
OutOfRange subclass: #MonthOutOfRange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exception Lesson-Date'!
OutOfRange subclass: #YearOutOfRange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exception Lesson-Date'!

!BadFormatDateEntry methodsFor: 'accessing' stamp: 'mu 6/16/2004 01:32'!
originalEntry
	^originalEntry
! !

!BadFormatDateEntry methodsFor: 'accessing' stamp: 'mu 6/15/2004 23:23'!
originalEntry: aString
	originalEntry _ aString.
! !

!BadFormatDateEntry methodsFor: 'exceptionDescription' stamp: 'mu 6/16/2004 01:39'!
messageText
	super messageText
		ifNotNil: [^ super messageText].
	^ 'フォーマットが不正です:' , self originalEntry asString
!]lang[(70 11 33)0,5,0! !


!BadFormatDateEntry class methodsFor: 'exceptionInstantiator' stamp: 'mu 6/16/2004 01:47'!
signalWithOriginalEntry: aString 
	^ self new originalEntry: aString;
		 signal
! !


!Date class methodsFor: '*exception Lesson-instance creation' stamp: 'mu 6/16/2004 02:10'!
safeFromString: aString 
	| elements year month day |
	elements _ aString findTokens: '/.-年月日'.
	elements size = 3
	   ifFalse: [BadFormatDateEntry signalWithOriginalEntry: aString].

	year _ (elements at: 1) asNumber.
	(year > 1900)
		ifFalse: [YearOutOfRange signalWithValue: year].

	month _ (elements at: 2) asNumber.
	(month between: 1 and: 12)
		ifFalse: [MonthOutOfRange signalWithValue: month].

	day _ (elements at: 3) asNumber.
	(day between: 1 and: 31)
		ifFalse: [DayOutOfRange signalWithValue: day].

	^ self
		newDay: day
		month: month
		year: year
!]lang[(90 3 471)0,5,0! !


!DateReader methodsFor: 'actions' stamp: 'mu 6/16/2004 17:48'!
readDateStrings: dateStrings 
	^ dateStrings
	   collect: [:each | [Date safeFromString: each]
			on: BadFormatDateEntry , OutOfRange
			do: [:ex | 
				PopUpMenu inform: ex description.
					ex return]]
! !

!DateReader methodsFor: 'actions' stamp: 'mu 6/16/2004 18:01'!
readDateStringsSilently: dateStrings 
	^ dateStrings
		collect: [:each | [Date safeFromString: each]
				on: BadFormatDateEntry , OutOfRange
				do: [:ex | ex return: Date today]]
! !


!DateReader class methodsFor: 'examples' stamp: 'mu 6/16/2004 17:58'!
example1
	"DateReader example1"
	| dateStrings reader dates |
	dateStrings _ #('2001/1/1' '12345' '1980/13/31' '1970年10月20日' ).
	reader _ DateReader new.
	dates _ reader readDateStrings: dateStrings.
	dates inspect!]lang[(116 1 2 1 2 1 91)0,5,0,5,0,5,0! !

!DateReader class methodsFor: 'examples' stamp: 'mu 6/16/2004 18:02'!
example2
	"DateReader example2"
	| dateStrings reader dates |
	dateStrings _ #('2001/1/1' '12345' '1980/13/31' '1970年10月20日' ).
	reader _ DateReader new.
	dates _ reader readDateStringsSilently: dateStrings.
	dates inspect!]lang[(116 1 2 1 2 1 99)0,5,0,5,0,5,0! !


!OutOfRange methodsFor: 'accessing' stamp: 'mu 6/16/2004 02:02'!
value
	^value
! !

!OutOfRange methodsFor: 'accessing' stamp: 'mu 6/16/2004 02:02'!
value: anObject
	value _ anObject
! !

!OutOfRange methodsFor: 'exceptionDescription' stamp: 'mu 6/16/2004 02:03'!
messageText
	super messageText
		ifNotNil: [^ super messageText].
	^ '範囲を超えています:' , self value asString
!]lang[(70 9 25)0,5,0! !


!OutOfRange class methodsFor: 'exceptionInstantiator' stamp: 'mu 6/16/2004 02:04'!
signalWithValue: anObject 
	^ self new value: anObject;
		 signal
! !

