﻿Object subclass: #DialLock
	instanceVariableNames: 'keyNumbers '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dial Lock Game'!

!DialLock methodsFor: 'initialization' stamp: 'mu 5/26/2004 19:07'!
initialize 
	keyNumbers _ #(7 7 7).	"デフォルトの鍵の番号は#(7 7 7)"!]lang[(37 11 9)0,5,0! !


!DialLock methodsFor: 'actions' stamp: 'mu 5/26/2004 19:13'!
open: numbers 
	(keyNumbers = numbers)	"キーが同じか?"
		ifTrue: [Transcript cr; show: '***開きました!!***']
!]lang[(40 6 39 5 7)0,5,0,5,0! !


!DialLock methodsFor: 'accessing' stamp: 'mu 5/26/2004 19:07'!
keyNumbers: anArrayOfInteger
	keyNumbers _ anArrayOfInteger
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DialLock class
	instanceVariableNames: ''!

!DialLock class methodsFor: 'instance creation' stamp: 'mu 5/26/2004 19:10'!
withKeyNumbers: anArrayOfInteger
	| inst |
	inst _ self new.
	inst keyNumbers: anArrayOfInteger.	"鍵を設定"
	^inst
!]lang[(98 4 9)0,5,0! !


DialLock subclass: #DialLockWithBomb
	instanceVariableNames: 'trials '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dial Lock Game'!

!DialLockWithBomb methodsFor: 'initialization' stamp: 'mu 5/26/2004 19:16'!
initialize
	super initialize.
	trials _ 0.
! !


!DialLockWithBomb methodsFor: 'actions' stamp: 'mu 5/26/2004 19:17'!
open: numbers 
	keyNumbers = numbers
		ifTrue: [Transcript cr; show: '***開きました!!***'.
			trials _ 0]
		ifFalse: [Transcript cr; show: '***はずれ!!***'.
			trials _ trials + 1].
	trials >= 5 ifTrue: [Transcript cr; show: '***ボカーン!!!!***'.
self initialize].
!]lang[(73 5 59 3 79 4 26)0,5,0,5,0,5,0! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DialLockWithBomb class
	instanceVariableNames: ''!

!DialLockWithBomb class methodsFor: 'instance creation' stamp: 'mu 5/26/2004 19:19'!
random
	^self withKeyNumbers: 
{10 atRandom. 10 atRandom. 10 atRandom. 10 atRandom}
! !
