﻿"String"

myString _ 'This is a string'.
myString class browseHierarchy.

"do:"
'This is a string' do: [:each | Transcript cr; show: each ].    "do it"
'We love Squeak' reject: [:each | each = $e].   "print it"
'Enjoy Smalltalk!' detect: [:each | each = $j]. "print it"

"連結"
#(1 2 3), #(4 5).
'Happy ', 'Squeaking!!'.

"比較"
'Squeaking!!' sameAs: 'SQUEAKING!!'		"print it"
'Squeaking!!' asUppercase = 'SQUEAKING!!'.

'*ction' match: 'Introduction'.
'*ction' match: 'Collection'.
'*ction' match: 'Fictions'.
'sQ###k' match: 'Squeak'.
'S#a##t##k' match: 'Smalltalk'.

"検索"
targetString _ 'Once upon a time, there was a language, called Smalltalk-80. Now its spirit is given a new body. That''s the Squeak!'.
targetString findString: 'Smalltalk' startingAt: 1.
targetString findString: 'Once' startingAt: 1.
targetString findString: 'Once' startingAt: 10.

"分割"
'#at:put:' findTokens: ':'.

'\lang\squeak\3.7' findTokens: '/\'.
'/lang/squeak/3.7' findTokens: '/\'.

"置換"
targetString _ 'Once upon a time, there was a language, called Smalltalk-80. Now its spirit is given a new body. That''s the Squeak!'.
copiedString _ targetString copyReplaceAll: 'a' with: 'ooo'.	"print it"

targetString _ 'Once upon a time, there was a language, called Smalltalk-80. Now its spirit is given a new body. That''s the Squeak!'.
targetString replaceAll: $a with: $o.
targetString.

"Character"
Character space inspect.
Character tab inspect.
Character cr inspect.

Character value: 99.
(Character value: 97) asciiValue.

"文字列への変換"
1 asString.
Date today asString.
'this is string' asString.

"asString, printString, storeString"
dictionary _ IdentityDictionary new.
dictionary at: #Smalltalk put: 'Cool'.
dictionary at: #Java put: 'Hot'.
dictionary asString inspect.
dictionary printString inspect.
dictionary storeString inspect.

'This is a string' asString inspect.
'This is a string' printString inspect.
#symbol asString inspect.
#symbol printString inspect.

"マルチバイトの文字列、文字"
stringA _ 'this is '.
stringB _ '文字列'.
stringC _ stringA, stringB.
stringC inspect.

stringC last inspect.

