﻿'From SqueakNihongo6.1 of 15 April 2004 [latest update: #0] on 9 June 2004 at 5:22:26 pm'!
Morph subclass: #MoleAttackMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mole Attack'!

!MoleAttackMorph methodsFor: 'initialization' stamp: 'mu 6/9/2004 17:20'!
initLayout
	| upFrame bottomFrame board button |
	"プロポーショナルレイアウトにする"
	self changeProportionalLayout.

	"上の部分 - MoleAttackBoardMorphを生成して貼る"
	upFrame _ LayoutFrame
			fractions: (0 @ 0 corner: 1 @ 0.8).
	board _MoleAttackBoardMorph new.
	self addMorph: board fullFrame: upFrame.
	"リサイズの対応"
	board submorphs
		do: [:each | 
			each hResizing: #spaceFill.
			each vResizing: #spaceFill].

	"下の部分 - ボタンを生成して貼る"
	bottomFrame _ LayoutFrame
			fractions: (0 @ 0.8 corner: 1 @ 1).
	button _ self buildButton.	"ボタンとなるモーフ生成".	
	self addMorph: button fullFrame: bottomFrame.

	self extent: 160 @ 100	"最初のサイズ"
!]lang[(51 16 37 4 23 7 142 7 101 4 3 10 97 11 77 6 2)0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0! !

!MoleAttackMorph methodsFor: 'initialization' stamp: 'mu 6/8/2004 23:32'!
initialize
	super initialize.
	self initLayout.
! !

!MoleAttackMorph methodsFor: 'building' stamp: 'mu 6/9/2004 17:18'!
buildButton
	^ SimpleButtonMorph new
		target: self;
		label: 'test1';
		actionSelector: #test2
! !

