﻿"Semaphore(1)"

left _ OrderedCollection new.
right _ OrderedCollection new.
sema _ Semaphore new.	"セマフォを生成"

interval _ Processor lowestPriority to: Processor highestPriority.
leftPriority _ interval atRandom.	"ランダムな優先度"
rightPriority _ interval atRandom.

leftProcess _ [100000 timesRepeat: [ left add: Time millisecondClockValue].
sema signal. "仕事が済んだシグナル"
] forkAt: leftPriority.
rightProcess _ [100000 timesRepeat: [ right add: Time millisecondClockValue].
sema signal. "仕事が済んだシグナル"
] forkAt: rightPriority.

2 timesRepeat: [sema wait].	"2回分のシグナルを待つ"

"結果のインスペクト"
{leftPriority->left last. 
rightPriority->right last. 
'Now Inspect' -> Time millisecondClockValue} inspect.

