﻿SmartSyntaxInterpreterPlugin subclass: #MyFirstPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plugin Lesson'!

!MyFirstPlugin methodsFor: 'primitives' stamp: 'mu 6/23/2004 18:08'!
primitiveFactorial: integer
	self primitive: 'primitiveFactorial' parameters: #(#SmallInteger).
	^self slangFactorial: integer
! !

!MyFirstPlugin methodsFor: 'primitives' stamp: 'mu 6/23/2004 00:57'!
primitiveGetMagicNumber
	self primitive: 'primitiveGetMagicNumber'.
	^ 86 asOop: SmallInteger
! !

!MyFirstPlugin methodsFor: 'primitives' stamp: 'mu 6/23/2004 18:33'!
primitiveReverse: indexableObject 
	self primitive: 'primitiveReverse' parameters: #(#Oop).
	^self slangReverse: indexableObject
! !


!MyFirstPlugin methodsFor: 'primitives-support' stamp: 'mu 6/23/2004 18:31'!
slangFactorial: integer
	| ret |
	integer <= 1 ifTrue: [^ 1 asOop: SmallInteger].
	ret _ 1.
	1 to: integer do: [:index | ret _ ret * index].
	^ ret asOop: SmallInteger
! !

!MyFirstPlugin methodsFor: 'primitives-support' stamp: 'mu 6/23/2004 18:28'!
slangReverse: indexableObj
	| sourceObj size srcIndex resultObj |
	sourceObj _ indexableObj.
	size _ interpreterProxy stSizeOf: indexableObj.
	interpreterProxy pushRemappableOop: sourceObj.
	resultObj _ interpreterProxy clone: indexableObj.
	sourceObj _interpreterProxy popRemappableOop.
	srcIndex _ size + 1.
	1 to: size 
		do: [:index |
		 interpreterProxy
		    stObject: resultObj
		    at: index
		    put: (interpreterProxy 
				stObject: sourceObj 
				at: (srcIndex _ srcIndex - 1))].
	^ resultObj
! !


Object subclass: #MyFirstPluginTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plugin Lesson'!

!MyFirstPluginTest methodsFor: 'actions' stamp: 'mu 6/23/2004 18:09'!
factorial: integer
	<primitive: 'primitiveFactorial' module: 'MyFirstPlugin'>
	self primitiveFailed
! !

!MyFirstPluginTest methodsFor: 'actions' stamp: 'mu 6/23/2004 17:34'!
getMagicNumber
	<primitive: 'primitiveGetMagicNumber' module: 'MyFirstPlugin'>
	self primitiveFailed
! !

!MyFirstPluginTest methodsFor: 'actions' stamp: 'mu 6/23/2004 18:34'!
reverse: indexableObj
	<primitive: 'primitiveReverse' module: 'MyFirstPlugin'>
	self primitiveFailed
! !
